"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

exports.default = abstraction;

var _mapvalues = require("@unction/mapvalues");

var _mapvalues2 = _interopRequireDefault(_mapvalues);

var _ramda = require("ramda");

var _validus = require("validus");

var _asForgedAttribute = require("./asForgedAttribute");

var _asForgedAttribute2 = _interopRequireDefault(_asForgedAttribute);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var removeEmpty = (0, _ramda.reject)(_ramda.isEmpty);

function abstraction(configuration) {
  var attributes = configuration.attributes;
  var _configuration$valida = configuration.validations,
      validations = _configuration$valida === undefined ? {} : _configuration$valida;

  var validateValidations = (0, _validus.validates)(validations);

  return function abstractionConfiguration(rawAttributes) {
    var data = (0, _mapvalues2.default)((0, _asForgedAttribute2.default)(rawAttributes))(attributes);
    var errors = removeEmpty(validateValidations(data));
    var isValid = (0, _ramda.isEmpty)(errors);

    return _extends({}, data, {
      __abstraction__: {
        errors: errors,
        isValid: isValid,
        validations: validations
      }
    });
  };
}